#include "Play.hpp"

#include <Graphics/Graphics.hpp>
#include <Graphics/Texture.hpp>
#include <Graphics/Font.hpp>

#include <iostream>
#include <fstream>
#include <string>



#include <vector>
using namespace std;
Play::Play() : mouse_pos(make_vector(0.0f, 0.0f)), laser(false), 
	       show_start(true), bad_end(false), good_end(false){
  
  
  
  for (int i = 0; i < 4; i++){
    ships [i] = true;
	ships_hl [i] = false;
  }
  
  ship_pos[0]= make_vector(-0.3f, 0.1f);
  ship_pos[1]= make_vector(-Graphics::aspectf()+0.6f, 0.5f);
  ship_pos[2]= make_vector(-Graphics::aspectf(), -.3f);
  ship_pos[3]= make_vector(Graphics::aspectf()-1.2f, -0.1f);
  
  ifstream myfile ("../DO_NOT_EDIT.txt");

  string line1;
  string line2;
  if (myfile.is_open())
  {
	getline (myfile,line1);
	cout << line1 << endl;
	getline (myfile,line2);
	cout << line2 << endl;
  }
  myfile.close();
  if (line1.compare("Shields = On") == 0){
	shields_on = true;
  }
  else if (line1.compare("Shields = Off") == 0){
	shields_on = false;
  }
  else 
	cout << "SYSTEM ERROR" << endl;
  if (line2.compare("Lasers = Off") == 0){
	lasers_on = false;
  }
  else if (line2.compare("Lasers = On") == 0){
	lasers_on = true;
  }
  else
	cout << "SYSTEM ERROR" << endl;
	
	cout << "Shields: " << ((shields_on)?"true":"false")<<endl;
	cout << "Lasers: " << ((lasers_on)?"true":"false")<<endl;
	
	lasers_text = false;
	shields_text = false;
	tint = false;
	//show_start = true;
	
	total_time = 0;
}

Play::~Play() {
}

void Play::draw() {
	glClearColor(0.5f, 0.5f, 0.5f, 0.0f);
	glClear(GL_COLOR_BUFFER_BIT);
	//Draw things here.
	Graphics::TextureRef tex = Graphics::get_texture("../space.png");
	if (tex.ref) {
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, tex->obj);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
	}
	
	
	glBegin(GL_QUADS);
	if (tint)
		glColor4f(1.0f, 0.5f, 0.5f, 1.0f);
	else	
		glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	glTexCoord2f(1.0f, 1.0f);
	glVertex2f(Graphics::aspectf(), 1.0f);
	glTexCoord2f(1.0f, 0.0f);
	glVertex2f(Graphics::aspectf(), -1.0f);
	glTexCoord2f(0.0f, 0.0f);
	glVertex2f(-Graphics::aspectf(), -1.0f);
	glTexCoord2f(0.0f, 1.0f);
	glVertex2f(-Graphics::aspectf(), 1.0f);
	glEnd();

	for (int i=0; i<4; i++){
	  if (ships[i]){
		tex = Graphics::get_texture("../ship.png");
	    if (tex.ref) {
	      glEnable(GL_TEXTURE_2D);
	      glBindTexture(GL_TEXTURE_2D, tex->obj);
	      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	      glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
	    }
	    		
	    glBegin(GL_QUADS);
		if (tint)
			glColor4f(1.0f, 0.5f, 0.5f, 1.0f);
		else if (ships_hl[i])
			glColor4f(0.5f, 1.0f, 0.5f, 1.0f);
		else
			glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	    glTexCoord2f(1.0f, 1.0f);
	    glVertex2f(ship_pos[i].x+1.0f, ship_pos[i].y+.5f);
	    glTexCoord2f(1.0f, 0.0f);
	    glVertex2f(ship_pos[i].x+1.0f, ship_pos[i].y);
	    glTexCoord2f(0.0f, 0.0f);
	    glVertex2f(ship_pos[i].x, ship_pos[i].y);
	    glTexCoord2f(0.0f, 1.0f);
	    glVertex2f(ship_pos[i].x, ship_pos[i].y+.5f);
	    glEnd();
	  
		if (ships_hl[i]){
			tex = Graphics::get_texture("../border.png");
			if (tex.ref) {
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, tex->obj);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
			}
			glBegin(GL_QUADS);
			glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
			glTexCoord2f(1.0f, 1.0f);
			glVertex2f(ship_pos[i].x+1.0f, ship_pos[i].y+.5f);
			glTexCoord2f(1.0f, 0.0f);
			glVertex2f(ship_pos[i].x+1.0f, ship_pos[i].y);
			glTexCoord2f(0.0f, 0.0f);
			glVertex2f(ship_pos[i].x, ship_pos[i].y);
			glTexCoord2f(0.0f, 1.0f);
			glVertex2f(ship_pos[i].x, ship_pos[i].y+.5f);
			glEnd();
		}
		
		if (ships_hl[i] && laser && lasers_on){
			tex = Graphics::get_texture("../explosion.png");
			if (tex.ref) {
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, tex->obj);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
			}
			glBegin(GL_QUADS);
			glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
			glTexCoord2f(1.0f, 1.0f);
			glVertex2f(ship_pos[i].x+1.0f, ship_pos[i].y+.5f);
			glTexCoord2f(1.0f, 0.0f);
			glVertex2f(ship_pos[i].x+1.0f, ship_pos[i].y);
			glTexCoord2f(0.0f, 0.0f);
			glVertex2f(ship_pos[i].x, ship_pos[i].y);
			glTexCoord2f(0.0f, 1.0f);
			glVertex2f(ship_pos[i].x, ship_pos[i].y+.5f);
			glEnd();
		}
	  
	  }
	  
	}
	
	tex = Graphics::get_texture("../target.png");
	if (tex.ref) {
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, tex->obj);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
	}
		
	glBegin(GL_QUADS);
	glColor4f(0.5f, 0.5f, 1.0f, 1.0f);
	glTexCoord2f(1.0f, 1.0f);
	glVertex2f(mouse_pos.x + 0.125f, mouse_pos.y + 0.125f);
	glTexCoord2f(1.0f, 0.0f);
	glVertex2f(mouse_pos.x + 0.125f, mouse_pos.y - 0.125f);
	glTexCoord2f(0.0f, 0.0f);
	glVertex2f(mouse_pos.x - 0.125f, mouse_pos.y - 0.125f);
	glTexCoord2f(0.0f, 1.0f);
	glVertex2f(mouse_pos.x - 0.125f, mouse_pos.y + 0.125f);
	glEnd();
	
	//alert the user that lasers are disabled
	if(lasers_text){
		Graphics::FontRef font = Graphics::get_font("hel.txf");
		assert(font.ref);
		glColor3f(0.5f, 1.0f, 0.5f);
		font->draw_center("Lasers are disabled!", make_vector(0.0f, -0.2f), 0.1f);
		
	}


	       	
	//draw lasers
	if (laser && lasers_on) {
		tex = Graphics::get_texture("../laser.png");
		if (tex.ref) {
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, tex->obj);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
			glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
		}
		glBegin(GL_QUADS);
		glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
		glTexCoord2f(1.0f, 0.0f);
		glVertex2f(mouse_pos.x + 0.1f, mouse_pos.y - 0.1f);
		glTexCoord2f(0.0f, 0.0f);
		glVertex2f(-Graphics::aspectf()+.1f, -1.0f);
		glTexCoord2f(0.0f, 1.0f);
		glVertex2f(-Graphics::aspectf(), -.9f);
		glTexCoord2f(1.0f, 1.0f);
		glVertex2f(mouse_pos.x - 0.1f, mouse_pos.y + 0.1f);
		
		glBegin(GL_QUADS);
		glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
		glTexCoord2f(1.0f, 0.0f);
		glVertex2f(mouse_pos.x + 0.1f, mouse_pos.y + 0.1f);
		glTexCoord2f(0.0f, 0.0f);
		glVertex2f(Graphics::aspectf(), -.9f);
		glTexCoord2f(0.0f, 1.0f);
		glVertex2f(Graphics::aspectf()-.1f, -1.0f);
		glTexCoord2f(1.0f, 1.0f);
		glVertex2f(mouse_pos.x - 0.1f, mouse_pos.y - 0.1f);
		
		glEnd();
	}
	
	if(shields_text){
	  Graphics::FontRef font = Graphics::get_font("hel.txf");
	  assert(font.ref);
	  glColor3f(0.5f, 1.0f, 0.5f);
	  font->draw_center("Enemy shields are active!", make_vector(0.0f, -0.2f), 0.085f);
	}

	Graphics::FontRef font = Graphics::get_font("hel.txf");
	assert(font.ref);
	glColor3f(1.0f, 0.5f, 0.5f);
	font->draw_center("We are under enemy fire!", make_vector(0.0f, +0.5f), 0.11f);
	
	//draw the bridge of the enterprise
	tex = Graphics::get_texture("../deck1.png");
	if (tex.ref) {
		glEnable(GL_TEXTURE_2D);
		glBindTexture(GL_TEXTURE_2D, tex->obj);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
		glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
	}
	glBegin(GL_QUADS);
	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	glTexCoord2f(1.0f, 1.0f);
	glVertex2f(Graphics::aspectf(), 1.0f);
	glTexCoord2f(1.0f, 0.0f);
	glVertex2f(Graphics::aspectf(), -1.0f);
	glTexCoord2f(0.0f, 0.0f);
	glVertex2f(-Graphics::aspectf(), -1.0f);
	glTexCoord2f(0.0f, 1.0f);
	glVertex2f(-Graphics::aspectf(), 1.0f);
	glEnd();

	if (show_start){
	  tex = Graphics::get_texture("../start.png");
	  if (tex.ref) {
	    glEnable(GL_TEXTURE_2D);
	    glBindTexture(GL_TEXTURE_2D, tex->obj);
	    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
	  }
	  glBegin(GL_QUADS);
	  glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	  glTexCoord2f(1.0f, 1.0f);
	  glVertex2f(Graphics::aspectf(), 1.0f);
	  glTexCoord2f(1.0f, 0.0f);
	  glVertex2f(Graphics::aspectf(), -1.0f);
	  glTexCoord2f(0.0f, 0.0f);
	  glVertex2f(-Graphics::aspectf(), -1.0f);
	  glTexCoord2f(0.0f, 1.0f);
	  glVertex2f(-Graphics::aspectf(), 1.0f);
	  glEnd();
	}
	
	if (bad_end){
	  tex = Graphics::get_texture("../badend.png");
	  if (tex.ref) {
	    glEnable(GL_TEXTURE_2D);
	    glBindTexture(GL_TEXTURE_2D, tex->obj);
	    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
	  }
	  glBegin(GL_QUADS);
	  glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	  glTexCoord2f(1.0f, 1.0f);
	  glVertex2f(Graphics::aspectf(), 1.0f);
	  glTexCoord2f(1.0f, 0.0f);
	  glVertex2f(Graphics::aspectf(), -1.0f);
	  glTexCoord2f(0.0f, 0.0f);
	  glVertex2f(-Graphics::aspectf(), -1.0f);
	  glTexCoord2f(0.0f, 1.0f);
	  glVertex2f(-Graphics::aspectf(), 1.0f);
	  glEnd();

	}

	if (good_end){
	  tex = Graphics::get_texture("../goodend.png");
	  if (tex.ref) {
	    glEnable(GL_TEXTURE_2D);
	    glBindTexture(GL_TEXTURE_2D, tex->obj);
	    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
	    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
	  }
	  glBegin(GL_QUADS);
	  glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	  glTexCoord2f(1.0f, 1.0f);
	  glVertex2f(Graphics::aspectf(), 1.0f);
	  glTexCoord2f(1.0f, 0.0f);
	  glVertex2f(Graphics::aspectf(), -1.0f);
	  glTexCoord2f(0.0f, 0.0f);
	  glVertex2f(-Graphics::aspectf(), -1.0f);
	  glTexCoord2f(0.0f, 1.0f);
	  glVertex2f(-Graphics::aspectf(), 1.0f);
	  glEnd();

	}
	
	Graphics::gl_errors("draw");
}

void Play::update(float elapsed_time) {
	//Update game state here.
	total_time += elapsed_time;
	
	bool still_going = false;
	for (int i=0; i<4; i++){
		still_going = (still_going || ships[i]);
	}
	
	if (((long)(total_time+0.5f)) % 2 == 0)
		tint = true;
	else
		tint = false;

	
	if (!still_going){
	  good_end = true;;
	}

	if (total_time >= 5 && show_start){
	  show_start = false;
	}
	
	if (total_time >= 10)
	  bad_end = true;
}

void Play::handle_event(SDL_Event const &event) {
	//Handle events here:
	if (event.type == SDL_KEYDOWN) {
		if (event.key.keysym.sym == SDLK_ESCAPE) {
			//escape quits.
			quit_screen(this);
		}
	}
	if (event.type == SDL_MOUSEMOTION) {
		mouse_pos.x = event.motion.x / float(Graphics::screen.x) * Graphics::aspectf() * 2.0f - Graphics::aspectf();
		mouse_pos.y = event.motion.y / float(Graphics::screen.y) *-2.0f + 1.0f;
		for (int i=0; i<4; i++)
		{
			if (mouse_pos.x>=ship_pos[i].x && mouse_pos.x<=ship_pos[i].x+ 1.0f &&
				mouse_pos.y>=ship_pos[i].y && mouse_pos.y<=ship_pos[i].y +.5f) {
				ships_hl[i] = true;
			}
			else
				ships_hl[i] = false;
		}
	}
	
	if (event.type == SDL_MOUSEBUTTONDOWN) {
	  if (show_start)
	    show_start = false;
	  else if (bad_end)
	    quit_screen(this);
	  else if (good_end)
	    quit_screen(this);
	  else {
		laser = true;
		if (lasers_on){
			if (!shields_on){
				for (int i=0; i<4; i++)
				{
					if (mouse_pos.x>=ship_pos[i].x && 
						mouse_pos.x<=ship_pos[i].x+ 1.0f &&
						mouse_pos.y>=ship_pos[i].y && 
						mouse_pos.y<=ship_pos[i].y +.5f) {
						ships[i] = false;
					}
				}
			}
			else
				shields_text = true;
		}
		else 
			lasers_text = true;
	  }
	}
	
	if (event.type == SDL_MOUSEBUTTONUP) {
		laser = false;
	}
}
